
/*
 * 根据前15位身份证号码得到完整的号码
 */
const getCompleteCodeOfUserCard = function(str = null) {
	if(!str) return null
    let weight = [7,9,10,5,8,4,2,1,6,3,7,9,10,5,8,4,2]
    let valid = ['1','0','X','9','8','7','6','5','4','3','2']
    let sum = 0
    let index = str.length
    while(index--){
    	sum += str.charAt(index) * weight[index]
    }
    return str + valid[sum % 11]
}

/**
 * 随机获得三级联动代码
 */
const buildRandomCityInfo = function(data = areas_data){
	data = data[buildRandomNumber(data.length)]
	// 避免脏数据
	data = Object.assign({},data)
	if(data.ch)
		data.ch = buildRandomCityInfo(data.ch)
	return data
}


// 全0正则验证
	const testAllZero = str => /^0+$/.test(str)


/**
 * 查询地区代码的城市信息数据树
 */
const queryCityInfoByCode = function(code = '000000', data = areas_data, str_before = ''){
	// code = '' + code
	let _code_before = (code = '' + code).substring(0,2)
	let _code_after  = code.substring(2)
	if(code == null || testAllZero(_code_before))
		return data
	// 本次匹配的code
	let _code = setBeforeOrAfterSomeSplitOfStr(str_before + _code_before, 6, false)
	for(let index in data){
		let city = data[index]
		if(city.co == _code){
			// 避免脏数据
			let _city = Object.assign({},city)
			if(_code_after == '' || testAllZero(_code_after))
				return _city
			else{
				_city.ch = queryCityInfoByCode(_code_after,_city.ch,str_before + _code_before)
				return _city
			}
		}
	}
}

/*
 * 随机得到一个身份证信息
 */
const buildRandomIdCard = function(cityCode = null, birthday = null, sex = 0){
	// 地区码处理
	let cityInfo,idCard = {}
	if(cityCode == null)
		cityInfo = buildRandomCityInfo()
	else
		cityInfo = queryCityInfoByCode(cityCode)
	if(cityInfo.length)
		cityInfo = buildRandomCityInfo(cityInfo)

	while(cityInfo.ch){
		if(cityInfo.ch.length){
			cityInfo.ch = buildRandomCityInfo(cityInfo.ch)
		}
		cityInfo.ch.na = cityInfo.na + cityInfo.ch.na
		cityInfo = cityInfo.ch
	}
	idCard.cityCode = cityInfo.co
	idCard.cityInfo = cityInfo.na
	delete idCard.co
	delete idCard.na
	// 生辰码处理
	idCard.birthday = buildStringDoAnything(birthday || buildRandomDate(),'/',function(str){
		return setBeforeOrAfterSomeSplitOfStr(str,times = 2)
	})
	// 顺序码处理
	idCard.index = setBeforeOrAfterSomeSplitOfStr(''+buildRandomNumber(100,1),2)
	// 性别码处理
	if(sex != 0){
		idCard.sex = buildRandomNumber(5, 0) * 2
		if(sex == 1)
			idCard.sex += 1
	}
	else
		idCard.sex = buildRandomNumber(10,1)
	// 效验码处理
	idCard.code = getCompleteCodeOfUserCard(idCard.cityCode + idCard.birthday + idCard.index + idCard.sex)
	return idCard
}

const first = firstName
const last = lastName

/**
 * 产生随机姓名
 */
const buildRandomNames = function(){
	let _t = last[buildRandomNumber(last.length)]
	return first[buildRandomNumber(first.length)] + _t[buildRandomNumber(_t.length)]
}


/**
 * 
 */
const sayAnyThing = function(strs){
	let _li = document.createElement('li')
	const createSpan = function(str){
		let _span = document.createElement('span')
		_span.innerHTML = str
		return _span
	}
	for(let i = 0 ; i < strs.length ; i++ )
		_li.appendChild(createSpan(strs[i]))
	$('#listIdCard').appendChild(_li)
}

const resetResult = function(){
	$('#listIdCard').innerHTML = ''
}
