/*
 * 查询节点
 */
const $ = function(query,parent = document){
	return /^#/.test(query) ? parent.querySelector(query) : parent.querySelectorAll(query)
}

/*
 * 查询子节点
 */
Node.prototype.find = function(query){
	return $(query, this)
}

/*
 * 设置/得到html代码
 */
Node.prototype.html = function(value = null){
	if(value == null){
		return this.innerHTML
	}
	this.innerHTML = value
	return this
}

const abs = function(numb){
	return numb > 0 ? numb : -numb
}

/*
 * 得到一个随机的数值
 */
const buildRandomNumber = function(max = 100, min = 0){
	return ~~(Math.random() * (max - min)) + min
}

/*
 * 得到一个随机的颜色
 */
const buildRandomColor = function(numb = buildRandomNumber(4096), times = 3) {
	return (times == 3 ? '#' : '') + [numb % 16, numb = ~~(numb / 16)][0].toString(16) + (--times ? buildRandomColor(numb, times) : '')
}

/*
 * 得到一个随机的日期
 */
const buildRandomDate = function(max = new Date(), min = new Date(1970,1,1)){
	return (new Date(buildRandomNumber(max.getTime()/1000,min.getTime()/1000)*1000)).toLocaleDateString()
}

/*
 * 前位/后位补位
 */
const setBeforeOrAfterSomeSplitOfStr = function(str = null,len = 2,isFirst = true,split = '0'){
	if(str == null) return null
	let _t = len - ('' + str).length
	_t < 0 && (_t = 0)
	// 多个split连接字符串
	let _tmp = new Array(_t + 1).join(split)
	return isFirst ? _tmp + str : str + _tmp
}


/*
 * 文字分割处理
 */
const buildStringDoAnything = function(str = null,split = ' ',func = null){
	let _arr = str.split(split)
	let _len = _arr.length
	let _res = ''
	for(let i = 0 ; i < _len ; i++)
		_res += func(_arr[i])
	return _res
}